-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
local materials = {"a_u","a_d","a_c","t_u","t_d","t_c","t_m","t_x"}
local materials_u = {}
local materials_v = {}
local mat_prop1, mat_prop2 = ""

local active = false

local function onInit()
	active = false
	for k, v in pairs(v.slotMap.ultrike_body_kit) do
		if v.active then
			active = true
			if v.partName == "ultrike_body_kit_prime" then name = "ultrike_cockpit_ins" end
			if v.partName == "ultrike_body_kit_sport" then name = "ultrike_cockpit_ins_2" end

			for x, m in pairs(materials) do
				
				for k, s in pairs(material.switches) do
					if k == "ultrike_screen_"..m.."|"..name then materials_u[x] = s end
					--print(k)
				end

				for i=0, 9, 1 do
					obj.ibody:getSwitchableMaterial("ultrike_screen_"..m, "ultrike_screen_"..i, name)
				end

				obj.ibody:getSwitchableMaterial("ultrike_screen_"..m, "ultrike_screen_transparent", name)

			end
			
			materials_v={}
		end
	end

		--Prop blur material change
	for k, s in pairs(material.switches) do
		--print(k)
		if k == "ultrike_propeller_moving|ultrike_propeller_blades_moving" then mat_prop1 = s end
		if k == "ultrike_propeller|ultrike_propeller_blades" then mat_prop2 = s end
	end
end

local function onReset()
	onInit()
end

local function updateGFX(dt)
	tm = bullettime['simulationSpeed']/100
	if active then
			--ias = math.max(0,((obj:getDirectionVector():dot(obj:getVelocity() - obj:getFlow())) * math.sqrt(obj:getDensityatNode(0) / 1.225)) * 1.94384449)
			ias = math.max(0,((obj:getDirectionVector():dot(obj:getVelocity() - obj:getFlow()))) * 1.94384449)
			
			u = math.floor(ias * 1)  % 10
			d = math.floor(ias * 0.1)  % 10
			c = math.floor(ias * 0.01)  % 10
			
			if ias < 10 then d=-1 end
			if ias < 100 then c=-1 end
			
			if materials_v[1] == nil or materials_v[1] ~= u then
				obj.ibody:switchMaterial(materials_u[1], "ultrike_screen_"..u)
			end
			
			if materials_v[2] == nil or materials_v[2] ~= d then
			if d==-1 then 
				obj.ibody:switchMaterial(materials_u[2], "ultrike_screen_transparent")
			else
				obj.ibody:switchMaterial(materials_u[2], "ultrike_screen_"..d)
			end
			end
			
			if materials_v[3] == nil or materials_v[3] ~= c then
			if c==-1 then 
				obj.ibody:switchMaterial(materials_u[3], "ultrike_screen_transparent")
			else
				obj.ibody:switchMaterial(materials_u[3], "ultrike_screen_"..c)
			end
			end
			
			materials_v[1]=u
			materials_v[2]=d
			materials_v[3]=c
			
			------
			alt = math.max(0,(obj:getPosition().z/0.3048)-1)
			
			u = math.floor(alt * 1)  % 10
			d = math.floor(alt * 0.1)  % 10
			c = math.floor(alt * 0.01)  % 10
			m = math.floor(alt * 0.001)  % 10
			x = math.floor(alt * 0.0001)  % 10
			
			if alt < 10 then d=-1 end
			if alt < 100 then c=-1 end
			if alt < 1000 then m=-1 end
			if alt < 10000 then x=-1 end
			
			if materials_v[4] == nil or materials_v[4] ~= u then
				obj.ibody:switchMaterial(materials_u[4], "ultrike_screen_"..u)
			end
		
			if materials_v[5] == nil or materials_v[5] ~= d then
			if d==-1 then 
				obj.ibody:switchMaterial(materials_u[5], "ultrike_screen_transparent")
			else
				obj.ibody:switchMaterial(materials_u[5], "ultrike_screen_"..d)
			end
			end
			
			if materials_v[6] == nil or materials_v[6] ~= c then
			if c==-1 then 
				obj.ibody:switchMaterial(materials_u[6], "ultrike_screen_transparent")
			else
				obj.ibody:switchMaterial(materials_u[6], "ultrike_screen_"..c)
			end
			end
			
			if materials_v[7] == nil or materials_v[7] ~= m then
			if m==-1 then 
				obj.ibody:switchMaterial(materials_u[7], "ultrike_screen_transparent")
			else
				obj.ibody:switchMaterial(materials_u[7], "ultrike_screen_"..m)
			end
			end
			
			if materials_v[8] == nil or materials_v[8] ~= x then
			if x==-1 then 
				obj.ibody:switchMaterial(materials_u[8], "ultrike_screen_transparent")
			else
				obj.ibody:switchMaterial(materials_u[8], "ultrike_screen_"..x)
			end
			end
			
			materials_v[4]=u
			materials_v[5]=d
			materials_v[6]=c
			materials_v[7]=m
			materials_v[8]=x
	end

	--Prop blur material change
	rpm=0
	for n,wd in pairs(drivetrain.wheels) do
			if wd.name == "Prop" then
				rpm=wd.angularVelocity*-1
			end
	end
	rpm = math.max(0, rpm* 9.5493)
	
	if mat_prop1 and mat_prop2 then
		if (rpm*tm) > (50*60/3) then
			obj.ibody:switchMaterial(mat_prop1, "ultrike_propeller_moving")
			obj.ibody:switchMaterial(mat_prop2, "ultrike_transparent")
		else
			obj.ibody:switchMaterial(mat_prop1, "ultrike_transparent")
			obj.ibody:switchMaterial(mat_prop2, "ultrike_propeller")
		end
	end

	--RPM Value Change
	for n,wd in pairs(drivetrain.wheels) do
			if wd.name == "Prop" then
				rpm=wd.angularVelocity*-1
			end
	end
	if rpm then drivetrain.rpm = math.max(0, rpm* 9.5493) end
end

-- public interface
M.onInit      = onInit
M.onReset     = onReset
M.updateGFX = updateGFX

return M